package de.mdelab.instanceGraphEditor.ui.commands;


import org.eclipse.gef.commands.Command;

import de.mdelab.instanceGraphEditor.ui.model.Node;

/**
 * Command used to changed the constraints of a node.
 *
 */
public class NodeHideCommand extends Command {

	private Node node;
	
	/**
	 * The command can be executed when all parameters have been set.
	 */
	@Override
	public boolean canExecute() {
	    return node != null ;//&& newConstraint != null;
	}
	
	/**
	 * The command can be undone if the node and old constraints are set.
	 */
	@Override
	public boolean canUndo() {
	    return false;//node != null && oldConstraint != null;
	}
	
	/**
	 * Save the old constraints and set new new constraints for the {@link OPMNode}.
	 */
	@Override public void execute() {
		System.out.println("hide node: " + node.getName());
			node.hideNode();
	}

	/**
	 * Restore the saved constraints to the {@link OPMNode}.
	 */
	@Override public void undo() {
	}
	
	public void setNode(final Node node) {
		this.node = node;
	}
}