package de.mdelab.instanceGraphEditor.ui.editor;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.ui.IEditorInput;
import org.eclipse.ui.IPersistableElement;

public class InstanceGraphEditorInput implements IEditorInput
{
	private final Resource	resource;
	
	private final EObject	object;

	public InstanceGraphEditorInput(Resource resource, EObject object)
	{
		assert resource != null;

		this.resource = resource;
		
		this.object = object;
	}


	public Resource getResource()
	{
		return this.resource;
	}
	
	public EObject getObject()
	{
		return object;
	}

	@Override
	public Object getAdapter(@SuppressWarnings("rawtypes") Class adapter)
	{
		return null;
	}

	@Override
	public boolean exists()
	{
		return false;
	}

	@Override
	public ImageDescriptor getImageDescriptor()
	{
		return ImageDescriptor.getMissingImageDescriptor();
	}

	@Override
	public String getName()
	{
		return "Story Diagram Debugger Instance Graph";
	}

	@Override
	public IPersistableElement getPersistable()
	{
		return null;
	}

	@Override
	public String getToolTipText()
	{
		return this.getName();
	}
}
