package de.mdelab.instanceGraphEditor.ui.model;

import java.util.ArrayList;
import java.util.List;
import java.util.Observable;

import org.eclipse.draw2d.geometry.Point;

public class Link extends Observable{
	
	private Node source, target;
	
	private String classifier;
	
	protected List<Point> bendpoints; 
		
	public Link(String classifier) {
		this.classifier = classifier;
		bendpoints = new ArrayList<Point>();
	}

	public String getClassifier() {
		return classifier;
	}

	public void setClassifier(String classifier) {
		this.classifier = classifier;
	}

	public void setSource(Node source) {
		if (this.source != null)
			source.removeSourceLink(this);
		this.source = source;
		source.addSourceLink(this);
	}
	
	public Node getSource() {
		return source;
	}

	public void setTarget(Node target) {
		if (this.target != null)
			target.removeTargetLink(this);
		this.target = target;
		target.addTargetLink(this);
	}

	public Node getTarget() {
		return target;
	}

	public void delete(){
		source.removeSourceLink(this);
		target.removeTargetLink(this);
	}
	
	public void addBendpoint(int index, Point location){
		bendpoints.add(index, location);
		setChanged();
		notifyObservers();
	}
	
	public void removeBendpoint(int index){
		bendpoints.remove(index);
		setChanged();
		notifyObservers();
	}
	
	public void setBendpoint(int index, Point location){
		bendpoints.set(index, location);
		setChanged();
		notifyObservers();
	}
	
	//return copy of the bendpoint
	public Point getBendpoint(int index){
		return new Point(bendpoints.get(index));
	}
	//return copy of the bendpoints
	public List<Point> getBendpoints(){
		return new ArrayList<Point>(bendpoints);
	}
}