package de.mdelab.instanceGraphEditor.ui.policies;

import org.eclipse.draw2d.geometry.Point;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.BendpointEditPolicy;
import org.eclipse.gef.requests.BendpointRequest;

import de.mdelab.instanceGraphEditor.ui.commands.LinkCreateBendpointCommand;
import de.mdelab.instanceGraphEditor.ui.commands.LinkDeleteBendpointCommand;
import de.mdelab.instanceGraphEditor.ui.commands.LinkMoveBendpointCommand;
import de.mdelab.instanceGraphEditor.ui.model.Link;
 
 
/**
 * Policy used by the {@link Link} to manage link bendpoints.
 *
 */
public class LinkBendpointEditPolicy extends BendpointEditPolicy {
	
	
  /**
   * {@inheritDoc}
   */
  @Override 
  protected Command getCreateBendpointCommand(final BendpointRequest request) {
	  LinkCreateBendpointCommand command = new LinkCreateBendpointCommand();
	  Point p = request.getLocation();
	  command.setConnection((Link) request.getSource().getModel());
	  command.setLocation(p);
	  command.setIndex(request.getIndex());
 
    return command;
  }
 
  /**
   * {@inheritDoc}
   */
  @Override protected Command getMoveBendpointCommand(final BendpointRequest request) {
    LinkMoveBendpointCommand command = new LinkMoveBendpointCommand();
 
    Point p = request.getLocation();
 
    command.setConnection((Link) request.getSource().getModel());
    command.setLocation(p);
    command.setIndex(request.getIndex());
 
    return command;
  }
 
  /**
   * {@inheritDoc}
   */
  @Override protected Command getDeleteBendpointCommand(final BendpointRequest request) {
    LinkDeleteBendpointCommand command = new LinkDeleteBendpointCommand();
 
    command.setConnection((Link)request.getSource().getModel());
    command.setIndex(request.getIndex());
    return command;
  }
}