package de.mdelab.instanceGraphEditor.ui.policies;

import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.DirectEditPolicy;
import org.eclipse.gef.requests.DirectEditRequest;

import de.mdelab.instanceGraphEditor.ui.commands.NodeAttributeValueEditCommand;
import de.mdelab.instanceGraphEditor.ui.figures.NodeFigure;
import de.mdelab.instanceGraphEditor.ui.model.Node;

public class NodeAttibuteValueDirectEditPolicy extends DirectEditPolicy {

	private String attributeName;
	
	@Override
	protected Command getDirectEditCommand(DirectEditRequest request) {
		
		NodeAttributeValueEditCommand command = new NodeAttributeValueEditCommand();
		String value  = ((String) request.getCellEditor().getValue());
		command.setModel((Node) getHost().getModel(), attributeName);
		command.setNewValue(value);
		attributeName = null;
		return command;
	}


	@Override
	protected void showCurrentEditValue(DirectEditRequest request) {
 		String value = (String) request.getCellEditor().getValue();
 		if (attributeName == null)
 			attributeName = ((NodeFigure) getHostFigure()).getSelectedAttribute().getText().split(" = ")[0];
// 		System.out.println("attributeName: " + attributeName + " value: "+ value);
		((NodeFigure) getHostFigure()).getSelectedAttribute().setText(value);
	}

}
