package de.mdelab.instanceGraphEditor.ui.provider;
/**
test class for a test graph
*/
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.draw2d.geometry.Point;
import org.eclipse.draw2d.geometry.Rectangle;

import de.mdelab.instanceGraphEditor.ui.model.InstanceGraphFactory;
import de.mdelab.instanceGraphEditor.ui.model.Link;
import de.mdelab.instanceGraphEditor.ui.model.Graph;
import de.mdelab.instanceGraphEditor.ui.model.Node;

public class ContentProvider {

	public static final ContentProvider INSTANCE = new ContentProvider();

	public Graph newSampleGraph() {
		Graph result = InstanceGraphFactory.INSTANCE.getGraph();
		Node first = newNode(200, 150, 65, 35, "first");
		Node second = newNode(300, 250, 65, 35, "second is very long , it's so long that connections may not work, what if it's even longer");
		Node third = newNode(100, 300, 65, 35, "third");
		Node third2 = newNode(100, 300, 65, 35, "third2");
		Node fourth = newNode(100, 300, 65, 35, "fourth");
		result.addNode(first);
		result.addNode(second);
		result.addNode(third);
		result.addNode(third2);
		result.addNode(fourth);
		newConnection(first, second);
		newConnection(first, third);
		//newConnection(first, third2);
		newConnection(second, fourth);
		return result;
	}

	private Node newNode(int x, int y, int width, int height, String name) {
		Node result = InstanceGraphFactory.INSTANCE.createNode(null, null, null);
		result.setConstraint(new Rectangle(new Point(x, y), new Dimension(width, height)));
		result.setName(name);
		return result;
	}
	
	private Link newConnection(Node source, Node target) {
		Link result = new Link(null);
		result.setSource(source);
		result.setTarget(target);
		return result;
		}
}